import os
import random
import sys

from PyQt5.QtWidgets import *
from PyQt5 import uic
from PyQt5.QtGui import *
from data import word_list


def resource_path(relative_path):  # ui 파일 가져오는 함수. 이 함수는 위키독스에서 가져온 것
    base_path = getattr(sys, "_MEIPASS", os.path.dirname(os.path.abspath(__file__)))
    return os.path.join(base_path, relative_path)


form_1 = resource_path('시작화면.ui') #
form_class_1 = uic.loadUiType(form_1)[0]
form_2 = resource_path('게임방법.ui')
form_class_2 = uic.loadUiType(form_2)[0]
form_3 = resource_path('게임화면.ui')
form_class_3 = uic.loadUiType(form_3)[0]


class MainWindow(QMainWindow, form_class_1):
    """시작화면 구성"""
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        self.setStyleSheet("background-color: white;") #뒷배경 흰색으로 구성
        self.setWindowTitle("행맨게임") #창 이름 흰색으로 구성

    def game_detail(self):
        """게임 방법으로 가는 함수"""
        self.hide() #현재 화면 숨겨주고
        page2 = Page2(self) #페이지 2로 불러오고
        page2.show() #페이지 2를 보여준다(show())

    def game_start(self):
        """게임 시작으로 가는 함수"""
        self.hide() # 현재 화면 숨겨주고
        page1 = Page1(self) #페이지 1 불러오고
        page1.show() #페이지 1을 보여준다.


class Page1(QMainWindow, form_class_3):  # 게임화면
    def __init__(self, parent):
        super().__init__(parent)

        self.setupUi(self)
        self.life = 14 #생명
        self.label_3.setNum(self.life)
        #라벨_3에 생명을 보여준다. 문자는 setText 숫자는 setNum을 사용한다.


        #각 버튼을 클릭할 때마다 함수에 연결시켜 준다.
        self.btn_a.clicked.connect(self.user_guess_to_editline)
        self.btn_b.clicked.connect(self.user_guess_to_editline)
        self.btn_c.clicked.connect(self.user_guess_to_editline)
        self.btn_d.clicked.connect(self.user_guess_to_editline)
        self.btn_e.clicked.connect(self.user_guess_to_editline)
        self.btn_f.clicked.connect(self.user_guess_to_editline)
        self.btn_g.clicked.connect(self.user_guess_to_editline)
        self.btn_h.clicked.connect(self.user_guess_to_editline)
        self.btn_i.clicked.connect(self.user_guess_to_editline)
        self.btn_j.clicked.connect(self.user_guess_to_editline)
        self.btn_k.clicked.connect(self.user_guess_to_editline)
        self.btn_l.clicked.connect(self.user_guess_to_editline)
        self.btn_m.clicked.connect(self.user_guess_to_editline)
        self.btn_n.clicked.connect(self.user_guess_to_editline)
        self.btn_o.clicked.connect(self.user_guess_to_editline)
        self.btn_p.clicked.connect(self.user_guess_to_editline)
        self.btn_q.clicked.connect(self.user_guess_to_editline)
        self.btn_r.clicked.connect(self.user_guess_to_editline)
        self.btn_s.clicked.connect(self.user_guess_to_editline)
        self.btn_t.clicked.connect(self.user_guess_to_editline)
        self.btn_u.clicked.connect(self.user_guess_to_editline)
        self.btn_v.clicked.connect(self.user_guess_to_editline)
        self.btn_w.clicked.connect(self.user_guess_to_editline)
        self.btn_x.clicked.connect(self.user_guess_to_editline)
        self.btn_y.clicked.connect(self.user_guess_to_editline)
        self.btn_z.clicked.connect(self.user_guess_to_editline)

        self.blank_answer = []  # _ 이 담길 빈 리스트
        self.chosen_word = random.choice(word_list) # 단어리스트에서 단어를 하나 선택함
        # print(self.chosen_word)  # 정답 확인용
        for j in range(0, len(self.chosen_word)): # 단어의 길이만큼 빈 리스트에 _을 넣어준다.
            self.blank_answer.append(" _ ")
        blank_answer_2 = ''.join(self.blank_answer)
        # 화면에는 []를 넣어서 출력되지 않게 join연산자를 작성해서 새로운 변수 blank_answer_2를 만들어 준다.
        self.lineEdit.setText(blank_answer_2) # 그리고 정답이 담길 칸에 blank_answer_2를 넣어준다.

        self.answer_list = []  ##정답이 담길 칸
        for i in self.chosen_word: #정답 단어를 하나씩 쪼개어 빈 리스트에 넣어준다.
            self.answer_list.append(i)
        # print(self.answer_list) #정담 확인용

    def user_guess_to_editline(self):
        """버튼을 눌렀을 때 맞는지 확인하는 부분"""
        sender = self.sender() #sender()를 사용하여 버튼의 객체를 가져와준다.
        btn_name = sender.text() #text()를 사용해 버튼의 이름을 가져와준다.
        # print(btn_name.lower()) #잘가져와지는지 확인용

        if btn_name.lower() in self.answer_list: #만약 누른 버튼의 알파벳의이 정답 리스트에 있다면
            num = 0
            for m in self.chosen_word:
                if btn_name.lower() == m:
                    self.blank_answer[num] = m
                num += 1
            print(self.blank_answer) #확인용
            self.lineEdit.setText(''.join(self.blank_answer))
            if self.answer_list == self.blank_answer:
                reply = QMessageBox()
                reply.setText(f"승리햇습니다!")
                reply.exec_()
        else: #누른 버튼의 알파벳이 정답 리스트에 없다면
            self.life -= 1 #생명을 하나 잃음
            self.image_show() #이미지를 보여주는 함수에 연결
            # print('생명을 잃음') 제작자 확인용
            self.label_3.setNum(self.life) #라벨에 생명이 줄어든 것을 업데이트 해줘야 함. setNum()이용
            if self.life == 0: #만약 생명이 0이라면
                reply = QMessageBox() #패배했다는 메세지박스 출력
                reply.setText(f"패배했습니다. 정답은 {self.chosen_word}이었습니다.") #정답인 단어도 알려주기
                reply.exec_() #메세지 박스를 닫아준다.

        print(self.answer_list, self.blank_answer) #확인용

    def image_show(self):
        """이미지를 보여주는 함수"""
        self.img_1 = QPixmap('hang_man_1.png') #각각의 이미지를 불러와줌
        self.img_2 = QPixmap('hang_man_2.png')
        self.img_3 = QPixmap('hang_man_3.png')
        self.img_4 = QPixmap('hang_man_4.png')
        self.img_5 = QPixmap('hang_man_5.png')
        self.img_6 = QPixmap('hang_man_6.png')
        self.img_7 = QPixmap('hang_man_7.png')
        self.img_8 = QPixmap('hang_man_8.png')
        self.img_9 = QPixmap('hang_man_9.png')
        self.img_10 = QPixmap('hang_man_10.png')
        self.img_11 = QPixmap('hang_man_11.png')
        self.img_12 = QPixmap('hang_man_12.png')
        self.img_13 = QPixmap('hang_man_13.png')
        self.img_14 = QPixmap('hang_man_14.png')

        if self.life == 13: #생명의 크기에 따라 보여줘야 할 이미지를 변경해줌
            self.label.setPixmap(self.img_1)
        if self.life == 12:
            self.label.setPixmap(self.img_2)
        if self.life == 11:
            self.label.setPixmap(self.img_3)
        if self.life == 10:
            self.label.setPixmap(self.img_4)
        if self.life == 9:
            self.label.setPixmap(self.img_5)
        if self.life == 8:
            self.label.setPixmap(self.img_6)
        if self.life == 7:
            self.label.setPixmap(self.img_7)
        if self.life == 6:
            self.label.setPixmap(self.img_8)
        if self.life == 5:
            self.label.setPixmap(self.img_9)
        if self.life == 4:
            self.label.setPixmap(self.img_10)
        if self.life == 3:
            self.label.setPixmap(self.img_11)
        if self.life == 2:
            self.label.setPixmap(self.img_12)
        if self.life == 1:
            self.label.setPixmap(self.img_13)
        if self.life == 0:
            self.label.setPixmap(self.img_14)
        self.label.show()

    def go_to_main(self):
        self.parent().show()
        self.hide()


class Page2(QMainWindow, form_class_2):  # 게임방법화면
    def __init__(self, parent):
        super().__init__(parent)
        self.setupUi(self)
        print("게임방법.")

    # btn_1 = QPushButton()
    # btn_1.clicked.connect(self.go_to_main)
    def go_to_main(self):
        self.parent().show()
        self.hide()


if __name__ == "__main__":
    app = QApplication(sys.argv)
    window = MainWindow()
    window.show()
    sys.exit(app.exec())
